if [ -d /data/adb/modules/aml ]; then
  AML=/data/adb/aml/DolbyAtmos/system
  if [ ! -d $AML/etc ]; then
    mkdir -p $AML/etc
  fi
  if [ ! -d $AML/vendor/etc ]; then
    mkdir -p $AML/vendor/etc
  fi
fi

MODDIR=${0%/*}
ACDB=/data/adb/modules/acdb
rm -f `find $MODDIR/system -type f -name *audio*effects*`
if [ ! -d $ACDB ] || [ -f $ACDB/disable ]; then
  NAME=dolbyatmos
  LIBPATH="\/vendor\/lib\/soundfx"
  LIB=libatmos.so
  UUID=74697567-7261-6564-6864-65726f206678
  if [ -d /sbin/.magisk ]; then
    MAGISKTMP=/sbin/.magisk
  else
    MAGISKTMP=`find /dev -mindepth 2 -maxdepth 2 -type d -name .magisk`
  fi
  ETC=$MAGISKTMP/mirror/system/etc
  VETC=$MAGISKTMP/mirror/vendor/etc
  AEC=`find $ETC -type f -name *audio*effects*.conf`
  VAEC=`find $VETC -type f -name *audio*effects*.conf`
  AEX=`find $ETC -type f -name *audio*effects*.xml`
  VAEX=`find $VETC -type f -name *audio*effects*.xml`
  METC=$MODDIR/system/etc
  MVETC=$MODDIR/system/vendor/etc
  cp -f $AEC $METC
  cp -f $VAEC $MVETC
  cp -f $AEX $METC
  cp -f $VAEX $MVETC
  MAEC=`find $MODDIR/system -type f -name *audio*effects*.conf`
  MAEX=`find $MODDIR/system -type f -name *audio*effects*.xml`
  sed -i "s/^libraries {/libraries {\n  $NAME {\n    path $LIBPATH\/$LIB\n  }/" $MAEC
  sed -i "s/^effects {/effects {\n  $NAME {\n    library $NAME\n    uuid $UUID\n  }/" $MAEC
  sed -i "1,/^    <\/libraries>/s/^    <\/libraries>/        <library name=\"$NAME\" path=\"$LIB\"\/>\n    <\/libraries>/" $MAEX
  sed -i "1,/^    <\/effects>/s/^    <\/effects>/        <effect name=\"$NAME\" library=\"$NAME\" uuid=\"$UUID\"\/>\n    <\/effects>/" $MAEX
fi

if [ ! -d /data/vendor/dolby ]; then
  mkdir -p /data/vendor/dolby
fi
chmod 0770 /data/vendor/dolby
chown 1013.1013 /data/vendor/dolby

if [ -f $MODDIR/cleaner.sh ]; then
  sh $MODDIR/cleaner.sh
  rm -f $MODDIR/cleaner.sh
fi


